# coding: utf-8
# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20231130


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class Message(object):
    """
    An message that represents a single dialogue of chat
    """

    def __init__(self, **kwargs):
        """
        Initializes a new Message object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param role:
            The value to assign to the role property of this Message.
        :type role: str

        :param content:
            The value to assign to the content property of this Message.
        :type content: list[oci.generative_ai_inference.models.ChatContent]

        """
        self.swagger_types = {
            'role': 'str',
            'content': 'list[ChatContent]'
        }

        self.attribute_map = {
            'role': 'role',
            'content': 'content'
        }

        self._role = None
        self._content = None

    @property
    def role(self):
        """
        **[Required]** Gets the role of this Message.
        Indicates who is giving the current message.


        :return: The role of this Message.
        :rtype: str
        """
        return self._role

    @role.setter
    def role(self, role):
        """
        Sets the role of this Message.
        Indicates who is giving the current message.


        :param role: The role of this Message.
        :type: str
        """
        self._role = role

    @property
    def content(self):
        """
        **[Required]** Gets the content of this Message.
        Contents of the chat message.


        :return: The content of this Message.
        :rtype: list[oci.generative_ai_inference.models.ChatContent]
        """
        return self._content

    @content.setter
    def content(self, content):
        """
        Sets the content of this Message.
        Contents of the chat message.


        :param content: The content of this Message.
        :type: list[oci.generative_ai_inference.models.ChatContent]
        """
        self._content = content

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
